using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using RNGClassLibrary;
using System.Data.Entity;
using System.Data.SqlClient;

namespace RNGWcfService1.ContextClass
{
    public class OtherMetalIssueDbContext:DbContext
    {
        public OtherMetalIssueDbContext() : base()
        {
            Database.SetInitializer<OtherMetalIssueDbContext>(null);
            base.Database.Connection.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings["RNGConnectionStrings"].ConnectionString;
        }

        public System.Data.Entity.DbSet<OtherMetalIssue> User { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<OtherMetalIssue>().MapToStoredProcedures();
        }


        public void GetErrorDescription(int ErrorNo, ref string ErrorDesc)
        {
            var pErrCodeParam = new SqlParameter("pErrorNo", ErrorNo);

            var pErrDescParam = new SqlParameter("pErrorDesc", System.Data.SqlDbType.VarChar, 200);
            pErrDescParam.Direction = System.Data.ParameterDirection.Output;
            pErrDescParam.Value = "";

            this.Database.ExecuteSqlCommand("spErrors_GetErrorDesc @pErrorNo, @pErrorDesc out", pErrCodeParam, pErrDescParam);

            ErrorDesc = Convert.ToString(pErrDescParam.Value);
        }



        public virtual int OtherMetalIssue_AddNew(DateTime date,string NameOfProcess,string UnitName,string Item,string Qty,string Remarks, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

            var paramdate = new SqlParameter("pdate", date);
            var paramNameOfProcess = new SqlParameter("pNameOfProcess", NameOfProcess);
            var paramUnitName = new SqlParameter("pUnitName", UnitName);
            var paramItem = new SqlParameter("pItem", Item);
            var paramQty = new SqlParameter("pQty", Qty);
            var paramRemarks = new SqlParameter("pRemarks", Remarks);
            var paramIsActive = new SqlParameter("pIsActive", IsActive);
            var paramUserID = new SqlParameter("pUserID", UserID);
            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);
            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_OtherMeatlIssue_AddNew @pdate,@pNameOfProcess,@pUnitName,@pItem,@pQty,@pRemarks,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam, paramdate, paramNameOfProcess, paramUnitName, paramItem, paramQty, paramRemarks, paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }

        public virtual int OtherMetalIssue_Edit(int MetalIssueId, DateTime date, string NameOfProcess, string UnitName, string Item, string Qty, string Remarks, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

            var paramMetalIssueId = new SqlParameter("pMetalIssueId", MetalIssueId);
            var paramdate = new SqlParameter("pdate", date);
            var paramNameOfProcess = new SqlParameter("pNameOfProcess", NameOfProcess);
            var paramUnitName = new SqlParameter("pUnitName", UnitName);
            var paramItem = new SqlParameter("pItem", Item);
            var paramQty = new SqlParameter("pQty", Qty);
            var paramRemarks = new SqlParameter("pRemarks", Remarks);
            var paramIsActive = new SqlParameter("pIsActive", IsActive);
            var paramUserID = new SqlParameter("pUserID", UserID);
            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);
            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_OtherMeatlIssue_Edit @pMetalIssueId,@pdate,@pNameOfProcess,@pUnitName,@pItem,@pQty,@pRemarks,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam, paramMetalIssueId, paramdate, paramNameOfProcess, paramUnitName, paramItem, paramQty, paramRemarks, paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }



        public virtual List<OtherMetalIssue> OtherMetalIssue_GetAll(int MetalIssueId)
        {
            var paramMetalIssueId = new SqlParameter("pMetalIssueId", MetalIssueId);


            return this.Database.SqlQuery<OtherMetalIssue>(
                            "Sp_OtherMeatlIssue_GetAll @pMetalIssueId",
                            paramMetalIssueId).ToList();
        }
    }
}